import React, { useState, useEffect } from 'react';
import axios from 'axios';
import '../styles/App.css';
import NationList from './items/Nation/NationList';
import './AddNation.css';

const hostURL = "http://localhost:8080";
const host = hostURL + "/api/1.0/nation";

//компонент для просмотра, создания и удаления уровней
const AddNation = () => {
    const [nationItems, setNationItems] = useState([]);
    
    //для создания нового уровня
    const [nation, setNation] = useState({nation: ''});

    //загрузка всех имеющихся уровней при старте
    useEffect(() => {
        getNations();
    }, [])

    //обновить список уровней
    function CheckArray(){
        getNations();
    }

    const getTokenForHeader = function () {
        return "Bearer " + localStorage.getItem("token");
    }

    const getNations = async function () {
        const requestParams = {
            method: "GET",
            headers: {
                "Authorization": getTokenForHeader(),
            }
        };
        const requestUrl = host + `/getNations`;
        const response = await fetch(requestUrl, requestParams);
        const data = await response.json();
        console.log(data);
        setNationItems(data);
    }

    //добавление нового уровня
    const addNewNation = async function (){
        if(nation.nation === ''){
            return;
        }
        else {
            const requestParams = {
                method: "POST",
                headers: {
                    "Content-Type": "application/json",
                    "Authorization": getTokenForHeader(),
                }
            };
            console.log(JSON.stringify(nation));
            const requestUrl = host + `/create/?nation=${nation.nation}`;
            const response = await fetch(requestUrl, requestParams);
            getNations();
            setNation({nation: ''});
        }
    }

    //добавили условную отрисовку
    return(
        <div>
            <div className="Group_create_level">
                <h1>Генератор наций</h1>
                <div>
                    <p style={{fontWeight: "900"}}>
                        Введите нацию:
                    <input
                        className="add-nation-input"
                        value={nation.nation}
                        onChange={e => setNation({nation: e.target.value})}
                    />
                    </p>
                </div>
                <div>
                    <button className='add-level-button'
                        onClick={addNewNation}
                    >
                        Создать нацию
                    </button>
                    <button className='add-level-button'
                         onClick={CheckArray}
                    >
                        Вывести все нации
                    </button>
                </div>
            </div>
            <div className="Card_list">
                {nationItems.length !== 0
                    ? 
                    <NationList nationItems={nationItems}
                    />
                    : 
                    <h1 style={{textAlign: 'center'}}>В БД отсутствуют какие-либо нации!</h1>
                }
            </div>
        </div>
    );
};

export default AddNation;